/* Exemplet visar hur man kan starta och stoppa en timer
   för en timeout eller ett intervall. */
// --------------------------------------------------
// Globala variabler och konstanter
let time1Id = null,
    time2Id = null,
    time3Id = null;                 // Id för timers
let msg1Elem, msg2Elem, msg3Elem;   // Element för meddeelanden
// --------------------------------------------------
// Initiering då webbsidan laddats in
function init() {
    msg1Elem = document.querySelector("#message1");
    msg2Elem = document.querySelector("#message2");
    msg3Elem = document.querySelector("#message3");
    document.querySelector("#start1Btn").addEventListener("click", startTimer1);
    document.querySelector("#stop1Btn").addEventListener("click", stopTimer1);
    document.querySelector("#start2Btn").addEventListener("click", startTimer2);
    document.querySelector("#stop2Btn").addEventListener("click", stopTimer2);
    document.querySelector("#start3Btn").addEventListener("click", startTimer3);
    document.querySelector("#stop3Btn").addEventListener("click", stopTimer3);
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------

// --------------------------------------------------
// Starta den första timern
function startTimer1() {
    if (time1Id != null) return;
    msg1Elem.innerText = "";
    time1Id = setTimeout(timeOut1, 2000);
} // Slut startTimer1
// --------------------------------------------------
// Stoppa den första timern
function stopTimer1() {
    clearTimeout(time1Id);
    msg1Elem.innerText = "Timern stoppades";
    time1Id = null;
} // Slut stopTimer1
// --------------------------------------------------
// Funktion som körs då tiden i timer 1 gått ut
function timeOut1() {
    msg1Elem.innerText = "Tiden är ute";
    time1Id = null;
} // Slut timeOut1
// --------------------------------------------------

// --------------------------------------------------
// Starta intervallet
function startTimer2() {
    if (time2Id != null) return;
    msg2Elem.innerText = "";
    time2Id = setInterval(timeOut2, 500);
} // Slut startTimer2
// --------------------------------------------------
// Stoppa intervallet
function stopTimer2() {
    clearInterval(time2Id);
    msg2Elem.innerText += " Stopp";
    time2Id = null;
} // Slut stopTimer2
// --------------------------------------------------
// Funktion som körs varje gång tiden gått ut i intervallet
function timeOut2() {
    msg2Elem.innerText += "x";
} // Slut timeOut2
// --------------------------------------------------

// --------------------------------------------------
// Starta den första timern
function startTimer3() {
    if (time3Id != null) return;
    msg3Elem.innerText = "";
    time3Id = setTimeout(timeOut3, 1000);
} // Slut startTimer3
// --------------------------------------------------
// Stoppa den första timern
function stopTimer3() {
    clearTimeout(time3Id);
    msg3Elem.innerText += " Stopp";
    time3Id = null;
} // Slut stopTimer3
// --------------------------------------------------
// Funktion som körs då tiden i timer 1 gått ut
function timeOut3() {
    msg3Elem.innerText += "x";
    let r = Math.floor(4 * Math.random()) + 2; // Tal mellan 2 och 5
    time3Id = setTimeout(timeOut3, r * 1000);
} // Slut timeOut3
// --------------------------------------------------
