/* Exemplet visar hur en enkel animering kan göras med ett tidsintervall.
   En funktion anropas med jämna mellanrum och för varje anrop flyttas
   ett element några pixlar. Värdena i xStep och boxTime avgör hastigheten. */
// --------------------------------------------------
// Globala variabler och konstanter
let playGround;     // Element för "spelytan"
let box;            // Element för boxen
let dir = 0;        // Riktning för boxens rörelse, 0=vänster, 1=höger
const xStep = 5;	// Antal pixlar som boxen ska förflytta sig i x-led
const boxTime = 20; // Tid mellan varje förflyttning av boxen
let timeId = null;  // Timer för boxen
// --------------------------------------------------
// Initiering då webbsidan laddats in
function init() {
    playGround = document.querySelector("#playGround");
    box = document.querySelector("#box");
    box.style.left = "100px";
    box.style.top = "120px";
    box.addEventListener("click", clickBox);
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Flytta boxen
function moveBox() {
    let p = playGround.getBoundingClientRect();
    let b = box.getBoundingClientRect();
    let x = parseInt(box.style.left);
    switch (dir) {
        case 0: // Vänster
            if (b.left - xStep >= p.left) {
                x -= xStep;
            }
            else {
                dir = 1;  // Byt riktning
            }
            break;
        case 1: // Höger
            if (b.right + xStep <= p.right) {
                x += xStep;
            }
            else {
                dir = 0;  // Byt riktning
            }
            break;
    }
    box.style.left = x + "px";
} // Slut moveBox
// --------------------------------------------------
// Kontrollera tangenter och flytta boxen åt vänster eller höger
function clickBox() {
    if (timeId) {
        clearInterval(timeId);
        timeId = null;
    }
    else {
        timeId = setInterval(moveBox, boxTime);
    }
} // Slut clickBox
// --------------------------------------------------
